import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.util.ArrayList;
/**
 * Cette classe est celle qui fait toutes les animations des parties du corps du personnage et donc place 
 * aussi touts ses membres de façon relative de sorte a pouvoir changer la taille du personnage sans avoir 
 * besoin de replacer les membres manuellement.
 * 
 * @author Arkin
 * @version 1.0
 */
public class Body extends Actor{
    /**
     * C'est ici que toute la mécanique liée au personnage est faite, toute les animations, le mouvement des portails et la gravité
     * 
     * @param mirror Utilisé pour définir le sens de changement
     * @param TPdirectionR est utilisé pour définir de quel côté du portail rouge sera téléporté le joueur
     * @param TPdirectionB est utilisé pour définir de quel côté du portail bleu sera téléporté le joueur
     * @param EndLevel est le paramètre qui est changé par la cellule de fin pour imobiliser le personnage
     */
    public int TPdirectionR;
    public int TPdirectionB;
    public boolean EndLevel = false;
    private int mirror = 0;
    private int test1=0;
    private int test2;
    private int x1 = 0;
    private int x2 = 0;
    private int changer = 0;
    private int l1 = 1;
    private int l2 = 1;
    private int max = 1;
    private int min = 1;
    private double WalkSpeed = 16;
    private int mover = 0;
    private int PortalMoveSpeed = 7;
    private float moveXr;
    private float moveYr;
    private float oldXr;
    private float oldYr;
    private float moveXb;
    private float moveYb;
    private float oldXb;
    private float oldYb;
    private int cellr = 0;
    private int cellb = 0;
    private int TPdelay = 0;
    private boolean testFOR1;
    private boolean testFOR2;
    private boolean fall = false;
    private int FallTime = 0;
    private Actor Bras_p1;
    private Actor Bras_p2;
    private Actor Bras;
    private Actor Jambe1_1;
    private Actor Jambe1_2;
    private Actor Jambe2_1;
    private Actor Jambe2_2;
    public Body(){
        scale();
        int j = -1;
        for(double i = 1;j != 1;i = i + 0.02){
            //System.out.println((int)(function1(i)*100));
            if((int)(function1(i)*100) > -10 && (int)(function1(i)*100) < 10 && j != 1){
                j++;
            }
            if((int)(function1(i)*100) > -10 && (int)(function1(i)*100) < 10 && j == 0){
                l1 = (int)i;
            }
            if((int)(function1(i)*100) > -10 && (int)(function1(i)*100) < 10 && j == 1){
                l2 = (int)i;
            }
        }
        int n = -1;
        for(float r = 1.0f;n != 1;r = r + 0.001f){
            //System.out.println((int)(DerFct1(r)*1000));
            if((int)(DerFct1(r)*1000) == 0 && n != 1){
                n++;
            }
            if((int)(DerFct1(r)*1000) == 0 && n == 0){
                max = (int)r;
            }
            if((int)(DerFct1(r)*1000) == 0 && n == 1){
                min = (int)r;
            }
        }
        test2 = l1;
    }
    private void addedToWorld(){
        Bras_p1 = getWorld().getObjects(bras_p1_1.class).get(0);
        Bras_p2 = getWorld().getObjects(bras_p1_2.class).get(0);
        Bras = getWorld().getObjects(bras_p2_1.class).get(0);
        Jambe1_1 = getWorld().getObjects(Jambe_p1_1.class).get(0);
        Jambe1_2 = getWorld().getObjects(Jambe_p1_2.class).get(0);
        Jambe2_1 = getWorld().getObjects(Jambe_p2_1.class).get(0);
        Jambe2_2 = getWorld().getObjects(Jambe_p2_2.class).get(0);
        Bras_p1.setLocation(getX()-((int)(this.getImage().getWidth()*0.2)) , getY()-(int)(this.getImage().getHeight()*0.2));
        Jambe1_1.setLocation(getX()-((int)(this.getImage().getWidth()*0.2)),getY()+((int)(this.getImage().getHeight()*0.35)));
        Jambe1_2.setLocation(getX()+((int)(this.getImage().getWidth()*0.2)),getY()+((int)(this.getImage().getHeight()*0.35)));
        Jambe2_2.setLocation(
            (int)((Jambe1_2.getX() + (double)(Jambe1_2.getImage().getWidth()*0.1)) + (double)(-Math.sin(Math.toRadians(function1(test2)))*(double)(Jambe1_2.getImage().getHeight()*0.48))),
            (int)(Jambe1_2.getY() + (double)(Math.cos(Math.toRadians(function1(test2)))*(Jambe1_2.getImage().getHeight()*0.5))));
        Jambe2_1.setLocation(
            (int)((Jambe1_1.getX() + (double)(Jambe1_1.getImage().getWidth()*0.1)) + (double)(-Math.sin(Math.toRadians(function1(test1)))*(double)(Jambe1_1.getImage().getHeight()*0.48))),
            (int)(Jambe1_1.getY() + (double)(Math.cos(Math.toRadians(function1(test1)))*(Jambe1_1.getImage().getHeight()*0.5))));
        Bras.setLocation(
            (int)(Bras_p1.getX() + (double)((Math.sin(Math.sin((double)-x2/(WalkSpeed/2))))*(Bras_p1.getImage().getHeight()*0.45))),
            (int)(Bras_p1.getY() + (double)(Math.abs(Math.cos((Math.sin((double)x2/(WalkSpeed/2)))))*(Bras_p1.getImage().getHeight()*0.45))));
    }
    /**
     * définit quelque variables de sorte a optimiser un maximum au niveau des "getWorld()" et lance la fonction qui calcule pour les animations
     */
    public void act(){
        Bras_p1 = getWorld().getObjects(bras_p1_1.class).get(0);
        Bras_p2 = getWorld().getObjects(bras_p1_2.class).get(0);
        Bras = getWorld().getObjects(bras_p2_1.class).get(0);
        Jambe1_1 = getWorld().getObjects(Jambe_p1_1.class).get(0);
        Jambe1_2 = getWorld().getObjects(Jambe_p1_2.class).get(0);
        Jambe2_1 = getWorld().getObjects(Jambe_p2_1.class).get(0);
        Jambe2_2 = getWorld().getObjects(Jambe_p2_2.class).get(0);
        if(Greenfoot.getMouseInfo() != null && EndLevel == false){
            action();
        }
    }
    private void action(){
        List<cell> Intersect = getWorld().getObjects(bras_p1_2.class).get(0).getIntersectingObjects(cell.class);
        List<portal_r> Intersect1 = getWorld().getObjects(bras_p1_2.class).get(0).getIntersectingObjects(portal_r.class);
        List<portal_b> Intersect2 = getWorld().getObjects(bras_p1_2.class).get(0).getIntersectingObjects(portal_b.class);
        //___________Teleportation_____________________________________________________________________________________________________________________________________________________________________________________
        TPdelay--;
        List<portal_r> PR = getObjectsInRange((int)(this.getImage().getWidth()*1.5), portal_r.class);
        List<portal_b> PB = getObjectsInRange((int)(this.getImage().getWidth()*1.5), portal_b.class);
        List<portal_r> PBasR = getObjectsAtOffset(0, 60, portal_r.class);
        List<portal_b> PBasB = getObjectsAtOffset(0, 60, portal_b.class);
        Actor cellFall = getOneObjectAtOffset(0,(int)(getImage().getHeight()*1.6), cell.class);
        if(PBasR.size() != 0 && getWorld().getObjects(portal_b.class).size() != 0){
            fall = true;
        }else if(PBasB.size() != 0 && getWorld().getObjects(portal_r.class).size() != 0){
            fall = true;
        }else if(cellFall == null){
            fall = true;
        }else{
            fall = false;
            FallTime = 0;
        }
        if(PB.size() != 0 && TPdelay <= 0){
            TPdelay = 7;
            switch(TPdirectionR) {
                case 0:
                    this.setLocation(getWorld().getObjects(portal_r.class).get(0).getX()+20,getWorld().getObjects(portal_r.class).get(0).getY());
                    break;
                case 1:
                    this.setLocation(getWorld().getObjects(portal_r.class).get(0).getX()-20,getWorld().getObjects(portal_r.class).get(0).getY());
                    break;
                case 2:
                    this.setLocation(getWorld().getObjects(portal_r.class).get(0).getX(),getWorld().getObjects(portal_r.class).get(0).getY()+20);
                    break;
                case 3:
                    this.setLocation(getWorld().getObjects(portal_r.class).get(0).getX(),getWorld().getObjects(portal_r.class).get(0).getY()-20);
                    break;
            }
        }
        if(PR.size() != 0 && TPdelay <= 0){
            TPdelay = 7;
            switch(TPdirectionB) {
                case 0:
                    this.setLocation(getWorld().getObjects(portal_b.class).get(0).getX()+20,getWorld().getObjects(portal_b.class).get(0).getY());
                    break;
                case 1:
                    this.setLocation(getWorld().getObjects(portal_b.class).get(0).getX()-20,getWorld().getObjects(portal_b.class).get(0).getY());
                    break;
                case 2:
                    this.setLocation(getWorld().getObjects(portal_b.class).get(0).getX(),getWorld().getObjects(portal_b.class).get(0).getY()+20);
                    break;
                case 3:
                    this.setLocation(getWorld().getObjects(portal_b.class).get(0).getX(),getWorld().getObjects(portal_b.class).get(0).getY()-20);
                    break;
            }
        }
        //___________Gravité_____________________________________________________________________________________________________________________________________________________________________________________
        Actor cellMove = getOneObjectAtOffset((int)(getImage().getWidth()*1.3),(int)(getImage().getHeight()/3), cell.class);
        Actor cellMove1 = getOneObjectAtOffset((int)-(getImage().getWidth()*1.3),0, cell.class);
        Actor cellMove2 = getOneObjectAtOffset((int)(getImage().getWidth()*1.3),0, Door_locked.class);
        Actor cellMove3 = getOneObjectAtOffset((int)-(getImage().getWidth()*1.3),0, Door_locked.class);
        List<cell> cellUP1 = getWorld().getObjects(Jambe_p2_1.class).get(0).getObjectsInRange((int)(Jambe2_1.getImage().getHeight()*0.5), cell.class); 
        List<cell> cellUP2 = getWorld().getObjects(Jambe_p2_2.class).get(0).getObjectsInRange((int)(Jambe2_2.getImage().getHeight()*0.5), cell.class);
        if(fall == false){
            if(cellUP1.size() != 0 || cellUP2.size() != 0){
                if(cellUP1.size() != 0){
                    testFOR1 = cellUP1.get(0).isGround1;
                }
                if(cellUP2.size() != 0){
                    testFOR2 = cellUP2.get(0).isGround1;
                }
                if(testFOR1 == true && testFOR2 == false){
                    this.setLocation(getX(),getY()-20);
                }else if(testFOR1 == false && testFOR2 == true){
                    this.setLocation(getX(),getY()-20);
                }else if(testFOR1 == true && testFOR2 == true){
                    this.setLocation(getX(),getY()-20);
                }else if(testFOR1 == false && testFOR2 == false){
                    this.setLocation(getX(),getY());
                }
            }
        }
        if(fall == true){
            while(FallTime < 60){
                FallTime++;
            }
            this.setLocation(getX(),(int)(getY()+racine(FallTime)));
        }else if(fall == false){
            this.setLocation(getX(),getY());
        }
        //___________Portal R_____________________________________________________________________________________________________________________________________________________________________________________
        if(Greenfoot.getMouseInfo() != null && Greenfoot.getMouseInfo().getButton() == 1 && Greenfoot.mouseClicked(null) && Intersect.size() == 0){
           if(getWorld().getObjects(portal_r.class).size() != 0){
               getWorld().removeObject(getWorld().getObjects(portal_r.class).get(0));
           }
           oldXr = (Bras_p2.getX() + (int)((float)Math.cos((float)Math.atan2(((float)(Greenfoot.getMouseInfo().getY()-Bras_p2.getY())), ((float)(Greenfoot.getMouseInfo().getX()-Bras_p2.getX()))))*Bras_p2.getImage().getWidth()/2));
           oldYr = (Bras_p2.getY() + (int)((float)Math.sin((float)Math.atan2(((float)(Greenfoot.getMouseInfo().getY()-Bras_p2.getY())), ((float)(Greenfoot.getMouseInfo().getX()-Bras_p2.getX()))))*Bras_p2.getImage().getWidth()/2));
           moveXr = ((float)Math.cos((float)Math.atan2(((float)(Greenfoot.getMouseInfo().getY()-Bras_p2.getY())), ((float)(Greenfoot.getMouseInfo().getX()-Bras_p2.getX()))))*PortalMoveSpeed);
           moveYr = ((float)Math.sin((float)Math.atan2(((float)(Greenfoot.getMouseInfo().getY()-Bras_p2.getY())), ((float)(Greenfoot.getMouseInfo().getX()-Bras_p2.getX()))))*PortalMoveSpeed);
           getWorld().addObject(new portal_r(oldXr,oldYr,moveXr,moveYr),(int)oldXr, (int)oldYr);
        }
        //___________Portal B_____________________________________________________________________________________________________________________________________________________________________________________
        if(Greenfoot.getMouseInfo() != null && Greenfoot.getMouseInfo().getButton() == 3 && Greenfoot.mouseClicked(null) && Intersect.size() == 0){
           if(getWorld().getObjects(portal_b.class).size() != 0){
               getWorld().removeObject(getWorld().getObjects(portal_b.class).get(0));
           }
           oldXb = (Bras_p2.getX() + (int)((float)Math.cos((float)Math.atan2(((float)(Greenfoot.getMouseInfo().getY()-Bras_p2.getY())), ((float)(Greenfoot.getMouseInfo().getX()-Bras_p2.getX()))))*Bras_p2.getImage().getWidth()/2));
           oldYb = (Bras_p2.getY() + (int)((float)Math.sin((float)Math.atan2(((float)(Greenfoot.getMouseInfo().getY()-Bras_p2.getY())), ((float)(Greenfoot.getMouseInfo().getX()-Bras_p2.getX()))))*Bras_p2.getImage().getWidth()/2));
           moveXb = ((float)Math.cos((float)Math.atan2(((float)(Greenfoot.getMouseInfo().getY()-Bras_p2.getY())), ((float)(Greenfoot.getMouseInfo().getX()-Bras_p2.getX()))))*PortalMoveSpeed);
           moveYb = ((float)Math.sin((float)Math.atan2(((float)(Greenfoot.getMouseInfo().getY()-Bras_p2.getY())), ((float)(Greenfoot.getMouseInfo().getX()-Bras_p2.getX()))))*PortalMoveSpeed);
           getWorld().addObject(new portal_b(oldXb,oldYb,moveXb,moveYb),(int)oldXb, (int)oldYb);
        }
        //___________Animation personnage_________________________________________________________________________________________________________________________________________________________________________________________
        if(Greenfoot.getMouseInfo() != null){
            getWorld().getObjects(traqueur.class).get(0).turnTowards((int)(Greenfoot.getMouseInfo().getX()),(int)(Greenfoot.getMouseInfo().getY()));
        }
        Bras_p2.setRotation(getWorld().getObjects(traqueur.class).get(0).getRotation());
        if(Greenfoot.getMouseInfo() != null && this.getX() < Greenfoot.getMouseInfo().getX()){
            if(mirror == 1){
                mirror = 0;
                Mirror();
                mirrorObjects();
            }
            if(!Greenfoot.isKeyDown("d") && !Greenfoot.isKeyDown("a") && getWorld().getObjects(Jambe_p1_1.class).get(0).getRotation() == 0 && x1 == 0){
                mover = 0;
            }
            if(mover == 0){
                Bras_p1.setLocation(getX()-((int)(this.getImage().getWidth()*0.2)) , getY()-(int)(this.getImage().getHeight()*0.2));
                getWorld().getObjects(traqueur.class).get(0).setLocation(getX()+((int)(this.getImage().getWidth()*0.25)) , getY()-(int)(this.getImage().getHeight()*0.2));
                Bras_p2.setLocation(
                getX()+((int)(this.getImage().getWidth()*0.25))+((int)(Math.cos(Math.toRadians(getWorld().getObjects(bras_p1_2.class).get(0).getRotation()))*(getWorld().getObjects(bras_p1_2.class).get(0).getImage().getWidth()/2))),
                getY()-(int)(this.getImage().getHeight()*0.2)+((int)(Math.sin(Math.toRadians(getWorld().getObjects(bras_p1_2.class).get(0).getRotation()))*(getWorld().getObjects(bras_p1_2.class).get(0).getImage().getWidth()/2))));
                Jambe1_1.setLocation(getX()-((int)(this.getImage().getWidth()*0.2)),getY()+((int)(this.getImage().getHeight()*0.35)));
                Jambe1_2.setLocation(getX()+((int)(this.getImage().getWidth()*0.2)),getY()+((int)(this.getImage().getHeight()*0.35)));
                Jambe2_2.setLocation(
                    (int)((Jambe1_2.getX() + (double)(Jambe1_2.getImage().getWidth()*0.1)) + (double)(-Math.sin(Math.toRadians(function1(test2)))*(double)(Jambe1_2.getImage().getHeight()*0.48))),
                    (int)(Jambe1_2.getY() + (double)(Math.cos(Math.toRadians(function1(test2)))*(Jambe1_2.getImage().getHeight()*0.5))));
                Jambe2_1.setLocation(
                    (int)((Jambe1_1.getX() + (double)(Jambe1_1.getImage().getWidth()*0.1)) + (double)(-Math.sin(Math.toRadians(function1(test1)))*(double)(Jambe1_1.getImage().getHeight()*0.48))),
                    (int)(Jambe1_1.getY() + (double)(Math.cos(Math.toRadians(function1(test1)))*(Jambe1_1.getImage().getHeight()*0.5))));
                Bras.setLocation(
                    (int)(Bras_p1.getX() + (double)((Math.sin(Math.sin((double)-x2/(WalkSpeed/2))))*(Bras_p1.getImage().getHeight()*0.45))),
                    (int)(Bras_p1.getY() + (double)(Math.abs(Math.cos((Math.sin((double)x2/(WalkSpeed/2)))))*(Bras_p1.getImage().getHeight()*0.45))));
                //rotations
                Jambe1_1.setRotation((int)function1(test1));
                Jambe1_2.setRotation((int)function1(test2));
                Jambe2_1.setRotation((int)(2*Math.toDegrees(Math.sin(Math.sin((double)x1/WalkSpeed)))));
                Jambe2_2.setRotation((int)(2.5*Math.toDegrees(Math.sin((double)x2/WalkSpeed))));
                Bras_p1.setRotation((int)(Math.toDegrees(Math.sin((double)x2/(WalkSpeed/2)))));
                Bras.setRotation((int)Math.toDegrees(Math.sin((double)x2/(WalkSpeed/2))*1.5)-45);
            }
            if(mover == 1){
                Bras_p1.setLocation(getX()-((int)(this.getImage().getWidth()*0.2)) , getY()-(int)(this.getImage().getHeight()*0.2));
                getWorld().getObjects(traqueur.class).get(0).setLocation(getX()+((int)(this.getImage().getWidth()*0.25)) , getY()-(int)(this.getImage().getHeight()*0.2));
                Bras_p2.setLocation(
                getX()+((int)(this.getImage().getWidth()*0.25))+((int)(Math.cos(Math.toRadians(getWorld().getObjects(bras_p1_2.class).get(0).getRotation()))*(getWorld().getObjects(bras_p1_2.class).get(0).getImage().getWidth()/2))),
                getY()-(int)(this.getImage().getHeight()*0.2)+((int)(Math.sin(Math.toRadians(getWorld().getObjects(bras_p1_2.class).get(0).getRotation()))*(getWorld().getObjects(bras_p1_2.class).get(0).getImage().getWidth()/2))));
                Jambe1_1.setLocation(getX()-((int)(this.getImage().getWidth()*0.2)),getY()+((int)(this.getImage().getHeight()*0.35)));
                Jambe1_2.setLocation(getX()+((int)(this.getImage().getWidth()*0.2)),getY()+((int)(this.getImage().getHeight()*0.35)));
                Jambe2_2.setLocation(
                    (int)((Jambe1_2.getX() + (double)(Jambe1_2.getImage().getWidth()*0.1)) + (double)(Math.sin(Math.sin(-x1/(WalkSpeed/2))*0.5)*(double)(Jambe1_2.getImage().getHeight()*0.48))),
                    (int)(Jambe1_2.getY() + (double)((Math.cos(Math.sin(-x1/(WalkSpeed/2))*0.5))*(Jambe1_2.getImage().getHeight()*0.5))));
                Jambe2_1.setLocation(
                    (int)((Jambe1_1.getX() + (double)(Jambe1_1.getImage().getWidth()*0.1)) + (double)(Math.sin(Math.sin(-x2/(WalkSpeed/2))*0.5)*(double)(Jambe1_1.getImage().getHeight()*0.48))),
                    (int)(Jambe1_1.getY() + (double)((Math.cos(Math.sin(-x2/(WalkSpeed/2))*0.5))*(Jambe1_1.getImage().getHeight()*0.5))));
                Bras.setLocation(
                    (int)(Bras_p1.getX() + (double)((Math.sin(0.3*(Math.sin((double)x2/(WalkSpeed/2)))))*(Bras_p1.getImage().getHeight()*0.45))),
                    (int)(Bras_p1.getY() + (double)(Math.abs(Math.cos(0.3*(Math.sin((double)x2/(WalkSpeed/2)))))*(Bras_p1.getImage().getHeight()*0.45))));
                //rotations
                Jambe1_1.setRotation((int)(Math.toDegrees(Math.sin(-x1/(WalkSpeed/2))*0.5)));
                Jambe1_2.setRotation((int)(Math.toDegrees(Math.sin(-x2/(WalkSpeed/2))*0.5)));
                Jambe2_1.setRotation((int)(1.5*function1(test2))+20);
                Jambe2_2.setRotation((int)(1.5*function1(test1))+20);
                Bras_p1.setRotation((int)(0.3*Math.toDegrees(Math.sin((double)-x2/(WalkSpeed/2)))));
                Bras.setRotation((int)Math.toDegrees(Math.sin((double)-x2/(WalkSpeed/2))*1.05)-45);
            }
            //marcher-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
            if(Greenfoot.isKeyDown("d") && !Greenfoot.isKeyDown("a")){
                mover = 0;
                if(changer == 0){
                    test1 = 0;
                    test2 = l1;
                    x1 = 0;
                    x2 = l2/2;
                    changer = 1;
                }
                //bouger personnage
                if(cellMove == null && cellMove2 == null && this.getX() < 1480){
                    this.setLocation(getX()+3,getY());
                }else{
                    this.setLocation(getX(),getY());
                }
                //animation jambe 1 partie 1
                test1++;
                if(test1 >= l2){
                    test1 = 0;
                }
                //animation jambe 2 partie 1
                test2++;
                if(test2 >= l2){
                    test2 = 0;
                }
                //mouvement jambe 1 partie 2
                x1++;
                if(x1 >= l2){
                    x1=0;
                }
                x2++;
                if(x2 >= l2){
                    x2=0;
                }
            }
            //transition position marcher -> normal jambe 1
            if(!Greenfoot.isKeyDown("d") && test1 != 0 && !Greenfoot.isKeyDown("a")){
                changer = 0;
                if(test1 < max){
                    test1--;
                }
                if(test1 >= max && test1 < l1){
                    test1++;
                }
                if(test1 > l1 && test1 < min){
                    test1--;
                }
                if(test1 >= min && test1 < l2){
                    test1++;
                }
                if(test1 >= l2 || test1 == l1){
                    test1 = 0;
                }
            }
            //transition position marcher -> normal jambe 2
            if(!Greenfoot.isKeyDown("d") && test2 != l1 && !Greenfoot.isKeyDown("a")){
                changer = 0;
                if(test2 > l1 && test2 < min){
                    test2--;
                }
                if(test2 >= min && test2 < l2){
                    test2++;
                }
                if(test2 < l1 && test2 >= max){
                    test2++;
                }
                if(test2 < max && test2 > 0){
                    test2--;
                }
                if(test2 == 0 || test2 >= l2){
                    test2 = l1;
                }
            }
            //transition position marcher -> normal jambe p2 1
            if(!Greenfoot.isKeyDown("d") && x1 != 0 && !Greenfoot.isKeyDown("a")){
                changer = 0;
                if(x1 > 0 && x1 <= (int)l2/4){
                    x1--;
                }
                if(x1 > (int)l2/4 && x1 < (int)l2/2){
                    x1++;
                }
                if(x1 > (int)l2/2 && x1 <= (int)3*l2/4){
                    x1--;
                }
                if(x1 > (int)3*l2/4 && x1 < (int)l2){
                    x1++;
                }
                if(x1 >= l2 || x1 == (int)l2/2){
                    x1 = 0;
                }
            }
            //transition position marcher -> normal jambe p2 2
            if(!Greenfoot.isKeyDown("d") && x2 != 0 && !Greenfoot.isKeyDown("a")){
                changer = 0;
                if(x2 > 0 && x2 <= (int)l2/4){
                    x2--;
                }
                if(x2 > (int)l2/4 && x2 < (int)l2/2){
                    x2++;
                }
                if(x2 > (int)l2/2 && x2 <= (int)3*l2/4){
                    x2--;
                }
                if(x2 > (int)3*l2/4 && x2 < (int)l2){
                    x2++;
                }
                if(x2 >= l2 || x2 == (int)l2/2){
                    x2 = 0;
                }
            }
            if(Greenfoot.isKeyDown("a") && !Greenfoot.isKeyDown("d")){
                mover = 1;
                if(changer == 0){
                    test1 = 0;
                    test2 = l1;
                    x1 = 0;
                    x2 = l2/2;
                    changer = 1;
                }
                //bouger personnage
                if(cellMove1 == null && cellMove3 == null && this.getX() > 20){
                    this.setLocation(getX()-2,getY());
                }else{
                    this.setLocation(getX(),getY());
                }
                //animation jambe 1 partie 1
                test1++;
                if(test1 >= l2){
                    test1 = 0;
                }
                //animation jambe 2 partie 1
                test2++;
                if(test2 >= l2){
                    test2 = 0;
                }
                //mouvement jambe 1 partie 2
                x1++;
                if(x1 >= l2){
                    x1=0;
                }
                x2++;
                if(x2 >= l2){
                    x2=0;
                }
                test1 = x1;
                test2 = x2;
            }
        }
        if(Greenfoot.getMouseInfo() != null && this.getX() > Greenfoot.getMouseInfo().getX()){
            if(mirror == 0){
                mirror = 1;
                Mirror();
                mirrorObjects();
            }
            if(!Greenfoot.isKeyDown("d") && !Greenfoot.isKeyDown("a") && Jambe1_1.getRotation() == 0 && x1 == 0){
                mover = 0;
            }
            if(mover == 0){
                Bras_p1.setLocation(getX()+((int)(this.getImage().getWidth()*0.2)) , getY()-(int)(this.getImage().getHeight()*0.2));
                getWorld().getObjects(traqueur.class).get(0).setLocation(getX()-((int)(this.getImage().getWidth()*0.25)) , getY()-(int)(this.getImage().getHeight()*0.2));
                Bras_p2.setLocation(
                getX()-((int)(this.getImage().getWidth()*0.25))+((int)(Math.cos(Math.toRadians(getWorld().getObjects(bras_p1_2.class).get(0).getRotation()))*(getWorld().getObjects(bras_p1_2.class).get(0).getImage().getWidth()/2))),
                getY()-(int)(this.getImage().getHeight()*0.2)+((int)(Math.sin(Math.toRadians(getWorld().getObjects(bras_p1_2.class).get(0).getRotation()))*(getWorld().getObjects(bras_p1_2.class).get(0).getImage().getWidth()/2))));
                Jambe1_1.setLocation(getX()+((int)(this.getImage().getWidth()*0.2)),getY()+((int)(this.getImage().getHeight()*0.35)));
                Jambe1_2.setLocation(getX()-((int)(this.getImage().getWidth()*0.2)),getY()+((int)(this.getImage().getHeight()*0.35)));
                Jambe2_1.setLocation(
                    (int)((Jambe1_1.getX() - (double)(Jambe1_1.getImage().getWidth()*0.1)) + (double)(Math.sin(Math.toRadians(function1(test1)))*(double)(Jambe1_1.getImage().getHeight()*0.48))),
                    (int)(Jambe1_1.getY() + (double)(Math.cos(Math.toRadians(function1(-test1)))*(Jambe1_1.getImage().getHeight()*0.5))));
                Jambe2_2.setLocation(
                    (int)((Jambe1_2.getX() - (double)(Jambe1_2.getImage().getWidth()*0.1)) + (double)(Math.sin(Math.toRadians(function1(test2)))*(double)(Jambe1_2.getImage().getHeight()*0.48))),
                    (int)(Jambe1_2.getY() + (double)(Math.cos(Math.toRadians(function1(-test2)))*(Jambe1_2.getImage().getHeight()*0.5))));
                Bras.setLocation(
                    (int)((Bras_p1.getX() + Bras_p1.getImage().getWidth()*0.1) + (double)(-Math.sin((double)(Math.sin((double)(Math.sin((double)-x2/(WalkSpeed/2))))))*(Bras_p1.getImage().getHeight()*0.48))),
                    (int)((Bras_p1.getY()- Bras_p1.getImage().getHeight()*0.07) + (double)(Math.abs(Math.cos((double)(Math.sin((double)(Math.sin((double)-x2/(WalkSpeed/2))))))*(Bras_p1.getImage().getHeight()*0.48)))));
                //rotations
                Jambe1_1.setRotation((int)function1(-test1));
                Jambe1_2.setRotation((int)function1(-test2));
                Jambe2_1.setRotation((int)(-2*Math.toDegrees(Math.sin(Math.sin((double)x1/WalkSpeed)))));
                Jambe2_2.setRotation((int)(-2*Math.toDegrees(Math.sin((double)x2/WalkSpeed)))+5);
                Bras_p1.setRotation((int)(Math.toDegrees(Math.sin((double)-x2/(WalkSpeed/2)))));
                Bras.setRotation((int)Math.toDegrees(Math.sin((double)x2/(WalkSpeed/2))*-1.5)+45);
            }
            if(mover == 1){
                Bras_p1.setLocation(getX()+((int)(this.getImage().getWidth()*0.2)) , getY()-(int)(this.getImage().getHeight()*0.2));
                getWorld().getObjects(traqueur.class).get(0).setLocation(getX()-((int)(this.getImage().getWidth()*0.25)) , getY()-(int)(this.getImage().getHeight()*0.2));
                Bras_p2.setLocation(
                getX()-((int)(this.getImage().getWidth()*0.25))+((int)(Math.cos(Math.toRadians(getWorld().getObjects(bras_p1_2.class).get(0).getRotation()))*(getWorld().getObjects(bras_p1_2.class).get(0).getImage().getWidth()/2))),
                getY()-(int)(this.getImage().getHeight()*0.2)+((int)(Math.sin(Math.toRadians(getWorld().getObjects(bras_p1_2.class).get(0).getRotation()))*(getWorld().getObjects(bras_p1_2.class).get(0).getImage().getWidth()/2))));
                Jambe1_1.setLocation(getX()+((int)(this.getImage().getWidth()*0.2)),getY()+((int)(this.getImage().getHeight()*0.35)));
                Jambe1_2.setLocation(getX()-((int)(this.getImage().getWidth()*0.2)),getY()+((int)(this.getImage().getHeight()*0.35)));
                Jambe2_1.setLocation(
                    (int)((Jambe1_1.getX() - (double)(Jambe1_1.getImage().getWidth()*0.1)) + (double)(-Math.sin(Math.sin(-x1/(WalkSpeed/2))*0.5)*(double)(Jambe1_1.getImage().getHeight()*0.48))),
                    (int)(Jambe1_1.getY() + (double)(Math.cos(Math.sin(-x1/(WalkSpeed/2))*0.5)*(Jambe1_1.getImage().getHeight()*0.5))));
                Jambe2_2.setLocation(
                    (int)((Jambe1_2.getX() - (double)(Jambe1_2.getImage().getWidth()*0.1)) + (double)(-Math.sin(Math.sin(-x2/(WalkSpeed/2))*0.5)*(double)(Jambe1_2.getImage().getHeight()*0.48))),
                    (int)(Jambe1_2.getY() + (double)(Math.cos(Math.sin(-x2/(WalkSpeed/2))*0.5)*(Jambe1_2.getImage().getHeight()*0.5))));
                Bras.setLocation(
                    (int)(Bras_p1.getX() + (double)((Math.sin(0.3*(Math.sin((double)x2/(WalkSpeed/2)))))*(Bras_p1.getImage().getHeight()*0.45))),
                    (int)(Bras_p1.getY() + (double)(Math.abs(Math.cos(0.3*(Math.sin((double)x2/(WalkSpeed/2)))))*(Bras_p1.getImage().getHeight()*0.45))));
                //rotations
                Jambe1_1.setRotation((int)(Math.toDegrees(Math.sin(-x1/(WalkSpeed/2))*0.5)));
                Jambe1_2.setRotation((int)(Math.toDegrees(Math.sin(-x2/(WalkSpeed/2))*0.5)));
                Jambe2_1.setRotation((int)(-1.5*function1(test1))-10);
                Jambe2_2.setRotation((int)(-1.5*function1(test2))-10);
                Bras_p1.setRotation((int)(0.3*Math.toDegrees(Math.sin((double)-x2/(WalkSpeed/2)))));
                Bras.setRotation((int)Math.toDegrees(Math.sin((double)x2/(WalkSpeed/2))*-1.05)+45);
            }
            //marcher------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
            if(Greenfoot.isKeyDown("a") && !Greenfoot.isKeyDown("d")){
                mover = 0;
                if(changer == 0){
                    test1 = 0;
                    test2 = l1;
                    x1 = 0;
                    x2 = l2/2;
                    changer = 1;
                }
                //bouger personnage
                if(cellMove1 == null && Intersect.size() == 0 && this.getX() > 20){
                    this.setLocation(getX()-3,getY());
                }else{
                    this.setLocation(getX(),getY());
                }
                //animation jambe 1 partie 1
                if(test1 < l2){
                    test1++;
                    if(test1 >= l2){
                        test1 = 0;
                    }
                }
                //animation jambe 2 partie 1
                if(test2 < l2){
                    test2++;
                    if(test2 >= l2){
                        test2 = 0;
                    }
                }
                //mouvement jambe 1 partie 2
                x1++;
                if(x1 >= l2){
                    x1=0;
                }
                //------------------------------
                //mouvement jambe 2 partie 2
                x2++;
                if(x2 >= l2){
                    x2=0;
                }
            }
            if(!Greenfoot.isKeyDown("a") && Greenfoot.isKeyDown("d")){
                mover = 1;
                if(changer == 0){
                    test1 = 0;
                    test2 = l1;
                    x1 = 0;
                    x2 = l2/2;
                    changer = 1;
                }
                //bouger personnage
                if(cellMove == null && this.getX() < 1480){
                    this.setLocation(getX()+2,getY());
                }else{
                    this.setLocation(getX(),getY());
                }
                //animation jambe 1 partie 1
                test1++;
                if(test1 >= l2){
                    test1 = 0;
                }
                //animation jambe 2 partie 1
                test2++;
                if(test2 >= l2){
                    test2 = 0;
                }
                //mouvement jambe 1 partie 2
                x1++;
                if(x1 >= l2){
                    x1=0;
                }
                x2++;
                if(x2 >= l2){
                    x2=0;
                }
                test1 = x1;
                test2 = x2;
            }
            //transition position marcher -> normal jambe 1
            if(!Greenfoot.isKeyDown("a") && test1 != 0 && !Greenfoot.isKeyDown("d")){
                if(test1 < max){
                    test1--;
                }
                if(test1 >= max && test1 < l1){
                    test1++;
                }
                if(test1 > l1 && test1 < min){
                    test1--;
                }
                if(test1 >= min && test1 < l2){
                    test1++;
                }
                if(test1 >= l2 || test1 == l1){
                    test1 = 0;
                }
            }
            //transition position marcher -> normal jambe 2
            if(!Greenfoot.isKeyDown("a") && test2 != l1 && !Greenfoot.isKeyDown("d")){
                if(test2 > l1 && test2 < min){
                    test2--;
                }
                if(test2 >= min && test2 < l2){
                    test2++;
                }
                if(test2 < l1 && test2 >= max){
                    test2++;
                }
                if(test2 < max && test2 > 0){
                    test2--;
                }
                if(test2 == 0 || test2 >= l2){
                    test2 = l1;
                }
            }
            //transition position marcher -> normal jambe p2 1
            if(!Greenfoot.isKeyDown("a") && x1 != 0 && !Greenfoot.isKeyDown("d")){
                if(x1 > 0 && x1 <= (int)l2/4){
                    x1--;
                }
                if(x1 > (int)l2/4 && x1 < (int)l2/2){
                    x1++;
                }
                if(x1 > (int)l2/2 && x1 <= (int)3*l2/4){
                    x1--;
                }
                if(x1 > (int)3*l2/4 && x1 < (int)l2){
                    x1++;
                }
                if(x1 >= l2 || x1 == (int)l2/2){
                    x1 = 0;
                }
            }
            //transition position marcher -> normal jambe p2 2
            if(!Greenfoot.isKeyDown("a") && x2 != 0 && !Greenfoot.isKeyDown("d")){
                changer = 0;
                if(x2 > 0 && x2 <= (int)l2/4){
                    x2--;
                }
                if(x2 > (int)l2/4 && x2 < (int)l2/2){
                    x2++;
                }
                if(x2 > (int)l2/2 && x2 <= (int)3*l2/4){
                    x2--;
                }
                if(x2 > (int)3*l2/4 && x2 < (int)l2){
                    x2++;
                }
                if(x2 >= l2 || x2 == (int)l2/2){
                    x2 = 0;
                }
            }
        }
    }
    private void scale(){
        GreenfootImage img = this.getImage();
        img.scale((int)(img.getWidth()/8),(int)(img.getHeight()/8));
    }
    /**
     * Change l'orientation des membres du personnages, permet la symétrie.
     */
    public void Mirror(){
        GreenfootImage img = this.getImage();
        img.mirrorHorizontally();
    }
    private void mirrorObjects(){
        getWorld().getObjects(Jambe_p1_1.class).get(0).mirror = 1;
        getWorld().getObjects(Jambe_p1_2.class).get(0).mirror = 1;
        getWorld().getObjects(Jambe_p2_1.class).get(0).mirror = 1;
        getWorld().getObjects(Jambe_p2_2.class).get(0).mirror = 1;
        getWorld().getObjects(bras_p1_1.class).get(0).mirror = 1;
        getWorld().getObjects(bras_p1_2.class).get(0).mirror = 1;
        getWorld().getObjects(bras_p2_1.class).get(0).mirror = 1;
    }
    private double function1(double x){
        return (double)(Math.toDegrees(Math.sin((double)(Math.sin((double)x/WalkSpeed)+Math.sin((double)x/WalkSpeed)+((double)x/WalkSpeed)))));
    }
    private float DerFct1(float x){
        return (float)Math.toDegrees(((Math.cos(Math.sin((float)x/WalkSpeed)+Math.sin((float)x/WalkSpeed)+(float)x/WalkSpeed)*Math.sin((float)x/WalkSpeed)+Math.cos(Math.sin((float)x/WalkSpeed)+Math.sin((float)x/WalkSpeed)+(float)x/WalkSpeed)*Math.cos((float)x/WalkSpeed)*Math.sin((float)x/WalkSpeed)+Math.cos(Math.sin((float)x/WalkSpeed)+Math.sin((float)x/WalkSpeed)+x/WalkSpeed)*Math.cos((float)x/WalkSpeed)*Math.sin((float)x/WalkSpeed))/(WalkSpeed*Math.sin((float)x/WalkSpeed))));
    }
    private float racine(int x){
        return (float)(2*Math.sqrt(0.05*x)*Math.exp(0.8));
    }
    /**
     * définit la variable TPdirectionR
     */
    public void setTPdirectionR(int test){
        TPdirectionR = test;
    }
    /**
     * définit la variable TPdirectionB
     */
    public void setTPdirectionB(int test1){
        TPdirectionB = test1;
    }
}