import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * cette classe est l'aura de la porte pour marquer si il est possible de l'ouvrir ou non.
 * 
 * @author Kylian Bezard et Alexandre Mascaro
 * @version 1.0
 */
public class Door_aura extends Actor
{
    /**
     * Act - do whatever the Door_aura wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    float i=0;
    int Width = 10;
    int Height = 10;
    /**
     * définit le caractéristiques de l'objet
     * @param image est utilisé pour définir l'image a utiliser
     */
    public Door_aura(String image){
        GreenfootImage img = new GreenfootImage(image);
        img.scale(img.getWidth() + 10,img.getHeight());
        img.setTransparency(150);
        Width = (int)(img.getWidth()/1.5);
        Height = (int)(img.getHeight()/2);
        this.setImage(img);
    }
    /**
     * cette fonction crée l'animation de grosissement et rétrécissement de l'aura
     */
    public void act(){
        i = i+0.05f;
        getImage().scale((int)(Width*(1+(float)2*Math.toRadians((float)Math.sin((float)i)))), Height);
    }
    /**
     * cet fonction est appelée pour supprimer cet objet dans le monde
     */
    public void Remove(){
        getWorld().removeObject(this);
    }
}
