import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.util.ArrayList;

/**
 * Cette classe est celle du portail bleu qui permet de se téléporter au portail rouge si il est existant.
 * 
 * @author Kylian Bezard et Alexandre Mascaro
 * @version 1.0
 */
public class portal_b extends Actor{
    GreenfootImage baseImage;
    private int imageRotation;
    private int move1 = 0;
    private float oldX;
    private float oldY;
    private float moveX;
    private float moveY;
 
    private List<cell> c;
    /**
     * définit les paramètres fondamentaux du portail lors de son aparition
     */
    public portal_b(float oldX1, float oldY1, float moveX1, float moveY1){
        baseImage = getImage();
        updateImage1();
        oldX = oldX1;
        oldY = oldY1;
        moveX = moveX1;
        moveY = moveY1;
    }
    private void updateImage1(){
        GreenfootImage image = new GreenfootImage(baseImage);
        
        if(move1 != 0){
            updateImage();
        }
        if(move1 == 1){
            List<cell> CellLeft = getObjectsAtOffset(-20,0,cell.class);
            List<cell> CellRight = getObjectsAtOffset(20,0,cell.class);
            List<cell> CellUp = getObjectsAtOffset(0,-20,cell.class);
            List<cell> CellDown = getObjectsAtOffset(0,20,cell.class);
            MyWorld w = (MyWorld)getWorld();
            
            if(CellLeft.size() != 0 && CellLeft.size() > CellUp.size() && CellLeft.size() > CellDown.size()){
               // getWorld().getObjects(Body.class).get(0).setTPdirectionR(0);
                
                w.theBody.setTPdirectionB(0);
            }
            if(CellRight.size() != 0 && CellRight.size() > CellUp.size() && CellRight.size() > CellDown.size()){
                //getWorld().getObjects(Body.class).get(0).setTPdirectionR(1);
                w.theBody.setTPdirectionB(1);
            }
            if(CellUp.size() != 0 && CellUp.size() > CellLeft.size() && CellUp.size() > CellRight.size()){
                //getWorld().getObjects(Body.class).get(0).setTPdirectionR(2);
                w.theBody.setTPdirectionB(2);
            }
            if(CellDown.size() != 0 && CellDown.size() > CellLeft.size() && CellDown.size() > CellRight.size()){
                //getWorld().getObjects(Body.class).get(0).setTPdirectionR(3);
                w.theBody.setTPdirectionB(3);
            }
            if(c.get(0).isGround1 == true){
                move1 = 3;
            }else if(c.get(0).isGround1 == false){
                move1 = 2;
            }
        }
        if(move1 == 0){
            image.scale(30, 30);
            setImage(image);
            oldX = oldX + moveX;
            oldY = oldY + moveY;
            this.setLocation((int)oldX,(int)oldY);
        }
    }
    private void updateImage(){
        if(move1 == 2){
            GreenfootImage image = new GreenfootImage(baseImage);
            image.rotate(imageRotation);
            image.scale(40, 80);
            setImage(image);
        }
        if(move1 == 3){
            GreenfootImage image = new GreenfootImage(baseImage);
            image.rotate(imageRotation);
            image.scale(80, 40);
            setImage(image);
        }
    }
    /**
     * lance les actions pour regarder si il arrive contre un mur ou un sol pour définir sa taille et sa forme.
     */
    public void act(){
        getWorld().getObjects(Jambe_p1_1.class).get(0).TPdirectionB = 3;
        c = getObjectsInRange(20, cell.class);
        if(c.size() != 0 && move1 == 0 && move1 == 0){
            move1 = 1;
        }         
        imageRotation += 2;
        updateImage1();
    }
}
